class GameLogic {

  int gameLevel = 0;

  int numParts = 2; //number of facial parts to target
  int currentPart; //keeps track of what part we're on
  int IMG_UPDATE = 4; //number times we need to punch until we change image
  int FACEPART_IMAGES = 3; //number of images for each face part
  int maxhits = IMG_UPDATE * FACEPART_IMAGES;
  
  PImage leftGlove, rightGlove;

  FacePart[] faceall = new FacePart[numParts]; //for now

  PVector convertedRightHand;
  PVector convertedLeftHand;
  PImage bg;
  int startTime;
  int endTime;
  int gameTime;

  GameLogic() {

    //intialize face parts: name, x, y, size
    faceall[0] = new FacePart("lefteye", 200, 200, 100);
    faceall[1] = new FacePart("righteye", 400, 200, 100);
    
    leftGlove = loadImage("left-hand.png");
    rightGlove = loadImage("right-hand.png");
    
  }//end constructor

  int getGameLevel() {
    return gameLevel;
  }

  void intro() {
    //Intro Scene
    bg = loadImage("calibration.jpg");
    background(bg);  
    PImage depth = kinect.depthImage();
    //image(depth, 0, 0);
    textAlign(CENTER);
    text("Stand like this to get your gloves on", width/2, 95);
    
    if (keyPressed == true) {
      startTime = millis();
      gameLevel=1; //go to play();
    }
  }

  void  play() {
    PImage depth = kinect.depthImage();
    image(depth, 0, 0);
    
    gameTime = millis() - startTime;
    int m = (gameTime % (1000*60*60)) / (1000*60);
    int s = ((gameTime % (1000*60*60)) % (1000*60)) / 1000;
    println("Your time: " + m +":" + s);
    println("now: "+ millis() + "       then: " +startTime);
    text(m +":"+s, width - 50, 20);
    

    // make a vector of ints to store the list of users
    IntVector userList = new IntVector();

    // write the list of detected users
    // into our vector
    kinect.getUsers(userList);

    // if we found any users
    if (userList.size() > 0) {
      // get the first user
      int userId = userList.get(0);

      // if we're successfully calibrated
      if ( kinect.isTrackingSkeleton(userId)) {
        // make a vector to store the left hand
        PVector rightHand = new PVector();
        // put the position of the left hand into that vector
        kinect.getJointPositionSkeleton(userId, SimpleOpenNI.SKEL_RIGHT_HAND, rightHand);

        PVector leftHand = new PVector();
        kinect.getJointPositionSkeleton(userId, SimpleOpenNI.SKEL_LEFT_HAND, leftHand);

        float angleInRadians = PVector.angleBetween(rightHand, leftHand);
        float angleInDegrees = degrees(angleInRadians);

        // convert the detected hand position
        // to "projective" coordinates
        // that will match the depth image
        convertedRightHand = new PVector();
        convertedLeftHand = new PVector();
        kinect.convertRealWorldToProjective(rightHand, convertedRightHand);
        kinect.convertRealWorldToProjective(leftHand, convertedLeftHand);

        // and display it      
        fill(255, 100, 200);
        ellipse(convertedRightHand.x, convertedRightHand.y, 10, 10);       
        ellipse(convertedLeftHand.x, convertedLeftHand.y, 10, 10);
        
        image(leftGlove, convertedLeftHand.x - 75, convertedLeftHand.y - 75);
        image(rightGlove, convertedRightHand.x - 75, convertedRightHand.y - 75);        
      }
    }




    //declare new area
    FacePart thisArea = faceall[currentPart];
    println("---Work that "  +thisArea.name);
    text("Work that "+thisArea.name, width/2, 100);
    int thisDamage = thisArea.damage();

    //println(thisDamage);
    if (thisDamage <= maxhits) {
      //thisDamage = thisArea.damage();
      println(thisArea.name + "'s damage is "+thisDamage);
      //thisArea.show(int (thisDamage / IMG_UPDATE));
      thisArea.show(thisDamage);
      thisArea.listenForHit(convertedRightHand.x, convertedRightHand.y);
      thisArea.listenForHit(convertedLeftHand.x, convertedLeftHand.y);
      thisDamage = thisArea.damage();

      if (thisDamage % IMG_UPDATE == 0 && thisDamage > 0 ) {
        println("--Update Image");
        thisArea.show(thisDamage);
      }
    }
    else {
      println("NEXT PART PLEASE!");
      currentPart++;
    }
    //if we got through all parts
    if (currentPart >= numParts) {
      endTime = millis();
      gameLevel = 2; //goes to end();
    }
  }//end play()


  void  end() {
    //stuff
    println("THE END");
    background(0);
    gameTime = endTime-startTime;
    int m = (gameTime % (1000*60*60)) / (1000*60);
    int s = ((gameTime % (1000*60*60)) % (1000*60)) / 1000;
    text("Your time: "+ m+"mins "+s+"s.", width/2, height /2);

//    //stop timer and post
//    int diff = endTime - startTime;
//    println("now: "+ endTime + "       then: " +startTime);
//    int m = (diff % (1000*60*60)) / (1000*60);
//    int s = ((diff % (1000*60*60)) % (1000*60)) / 1000;
//    println("Your time: " + m +":" + s);
  }
}//end class GameLogic

